/**
 * Cre le 29 janv. 2004
 * Par Sbastien Gougeon
 * Centre de Ressources Informatiques
 * Universit de Rennes 1
 * sebastien.gougeon@univ-rennes1.fr
 * 
 */
package fr.univrennes1.cri.test;


import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import com.novell.ldap.LDAPConnection;

import fr.univrennes1.cri.utils.ApoCasProxyException;
import fr.univrennes1.cri.utils.Connexion;

public class TestConnexion {
    
    private String numero = null;
    private String dateNaiss = null;
    Connection connect = null;
    
     /**
     * fonction qui test si l'annuaire ldap est accessible ou pas
     * @return un String renvoyant soit une exception si erreur rencontre, soit success si la connection  ldap a fonctionn
     */
    public String testLDAP()
    {
        	String result = "successLDAP";
        	
        	LDAPConnection lc = new LDAPConnection();

        	try {
    		    lc.connect("ldapglobal.univ-rennes1.fr", 389);    		        
    		    lc.bind("dc=univ-rennes1,dc=fr,ou=people", "");        
    		 }
        	 catch(Exception ldapexception) {        	 	
    		    result = ldapexception.toString();
    		}   		
        	 return result;
    }
    /**
     * fonction qui teste la connexion  Apoge
     * @return un String renvoyant soit une exception si erreur rencontre, soit success si la connection  Apoge a fonctionn
     * @throws ApoCasProxyException
     */
    public String testApogee() throws ApoCasProxyException {
        ResultSet res = null;
        PreparedStatement pstmt = null;
        String result = "successApogee";
        try{
			connect = Connexion.OpenConnection();
            pstmt = connect.prepareStatement("SELECT * FROM DEPARTEMENT where COD_DEP='971'");
            res = pstmt.executeQuery();
            if (!res.next()){
                result = "Pas d'individu dans la table";
            }
        }
        catch (Exception e)
        {
            e.printStackTrace();
            result = e.toString();
        }finally{
			try {
				if (res != null) res.close();
				if (pstmt != null) pstmt.close();
				if (connect != null) Connexion.CloseConnection(connect);
			}
			catch (Exception e) {
				throw new ApoCasProxyException("Erreur fermeture connexion : "+e);
			}

        }
        return result;
        
    }    
}